/*
 * s16vector - signed 16bit integer vector
 *
 *  (c) 1999 Shiro Kawai  shiro@acm.org
 *  Terms and conditions to use, modify or distribute this code
 *  is the same as of STk.
 *
 *  $Id: s16vector.c,v 1.2 1999/11/08 11:22:24 shiro Exp $
 */

#include "uvector.h"

#define TAG               s16
#define TAGTYPE           signed short
#define XVECTOR_TYPE      S16VECTOR
#define XVECTORP(obj)     S16VECTORP(obj)
#define XVECTOR_DATA(obj) S16VECTOR_DATA(obj)
#define XVECTOR_MARK      NULL

#define ASSERT_TAGTYPE(obj) \
    do {                                                        \
        if (!EXACTP(obj)) Serror("exact number required", obj); \
    } while (0)

#define BOX_TAGTYPE(obj, val) \
    obj = STk_makeinteger((long)(val))

#define UNBOX_TAGTYPE(val, obj) \
    do {                                        \
        ASSERT_TAGTYPE(obj);                    \
        val = STk_integer2long(obj);            \
    } while (0)

#define COMPARE_TAGTYPE(val1, val2) \
    ((val1) == (val2))

#define PUTS_TAGTYPE(val, buf, port) \
    sprintf(buf, "%d", (int)(val)); Puts(buf, port);


#include "uv_templ.c"
