/*
 * s32vector - signed 32bit integer vector
 *
 *  (c) 1999 Shiro Kawai  shiro@acm.org
 *  Terms and conditions to use, modify or distribute this code
 *  is the same as of STk.
 *
 *  $Id: s32vector.c,v 1.3 1999/11/08 11:34:19 shiro Exp $
 */

#include "uvector.h"

#define TAG               s32
#define TAGTYPE           signed long
#define XVECTOR_TYPE      S32VECTOR
#define XVECTORP(obj)     S32VECTORP(obj)
#define XVECTOR_DATA(obj) S32VECTOR_DATA(obj)
#define XVECTOR_MARK      NULL

#define ASSERT_TAGTYPE(obj) \
    if (!EXACTP(obj)) Serror("exact number required", obj)

#define BOX_TAGTYPE(obj, val) \
    obj = STk_makeinteger(val)

#define UNBOX_TAGTYPE(val, obj) \
    do {                                        \
        ASSERT_TAGTYPE(obj);                    \
        val = STk_integer_value_no_overflow(obj); \
    } while (0)

#define COMPARE_TAGTYPE(val1, val2) \
    ((val1) == (val2))

#define PUTS_TAGTYPE(val, buf, port) \
    sprintf(buf, "%ld", val); Puts(buf, port);


#include "uv_templ.c"
