/*
 * s64vector - signed 64bit integer vector
 *
 *  (c) 1999 Shiro Kawai  shiro@acm.org
 *  Terms and conditions to use, modify or distribute this code
 *  is the same as of STk.
 *
 *  $Id: s64vector.c,v 1.2 1999/11/08 11:22:24 shiro Exp $
 */

/*
 *  This version is a dummy implementation, just to complete
 *  SRFI-4 vector types.  Elements are just SCM objects now.
 */

#include "uvector.h"

#define TAG               s64
#define TAGTYPE           SCM
#define XVECTOR_TYPE      S64VECTOR
#define XVECTORP(obj)     S64VECTORP(obj)
#define XVECTOR_DATA(obj) S64VECTOR_DATA(obj)
#define XVECTOR_MARK      s64vector_mark

#define ASSERT_TAGTYPE(obj) \
    if (!EXACTP(obj)) Serror("exact number required", obj)

#define BOX_TAGTYPE(obj, val) \
    obj = val

#define UNBOX_TAGTYPE(val, obj) \
    do {                                        \
        ASSERT_TAGTYPE(obj);                    \
        val = obj;                              \
    } while (0)

#define COMPARE_TAGTYPE(val1, val2) \
    STk_equal(val1, val2)

#define PUTS_TAGTYPE(val, buf, port) \
    Puts(CHARS(STk_number2string((val), UNBOUND)), port);

#define XVECTOR_EXTRA_INIT(obj)                         \
    do {                                                \
        int len = UVECTOR_LENGTH(obj);                  \
        SCM *data = S64VECTOR_DATA(obj);                \
        int i;                                          \
        for (i=0; i<len; i++) *data++ = STk_makeinteger(0); \
    } while (0)

static void s64vector_mark(SCM obj)
{
    int i, len = UVECTOR_LENGTH(obj);
    SCM *data = S64VECTOR_DATA(obj);
    for (i=0; i<len; i++) STk_gc_mark(*data++);
}

#include "uv_templ.c"
