/*
 * u16vector - unsigned 16bit integer vector
 *
 *  (c) 1999 Shiro Kawai  shiro@acm.org
 *  Terms and conditions to use, modify or distribute this code
 *  is the same as of STk.
 *
 *  $Id: u16vector.c,v 1.2 1999/11/08 11:22:24 shiro Exp $
 */

#include "uvector.h"

#define TAG               u16
#define TAGTYPE           unsigned short
#define XVECTOR_TYPE      U16VECTOR
#define XVECTORP(obj)     U16VECTORP(obj)
#define XVECTOR_DATA(obj) U16VECTOR_DATA(obj)
#define XVECTOR_MARK      NULL

#define ASSERT_TAGTYPE(obj) \
    do {                                                \
        if (!EXACTP(obj)) {                             \
            Serror("exact number required", obj);       \
        } else if (STk_negativep(obj) == Truth) {       \
            Serror("positive number required", obj);    \
        }                                               \
    } while (0)

#define BOX_TAGTYPE(obj, val) \
    obj = STk_makeunsigned((unsigned long)(val))

#define UNBOX_TAGTYPE(val, obj) \
    do {                                        \
        ASSERT_TAGTYPE(obj);                    \
        val = STk_integer2ulong(obj);           \
    } while (0)

#define COMPARE_TAGTYPE(val1, val2) \
    ((val1) == (val2))

#define PUTS_TAGTYPE(val, buf, port) \
    sprintf(buf, "%u", (unsigned int)(val)); Puts(buf, port);

#include "uv_templ.c"
